<template>
  <el-main class="content">
    <el-row
      class="el-row"
      v-for="(projList, lindex) in projRowList"
      :key="lindex"
    >
      <el-col
        class="el-col"
        v-for="(proj, index) in projList"
        :key="index"
        :span="4"
        :offset="index > 0 ? 2 : 1"
      >
        <el-card
          v-contextmenu:contextmenu
          :body-style="{ padding: '0px' }"
          @contextmenu.prevent.native="openContextMenu"
          class="card_style"
        >
          <img
            src="https://shadow.elemecdn.com/app/element/hamburger.9cf7b091-55e9-11e9-a976-7f4d0b07eef6.png"
            class="image"
            @click="openproj(lindex, index)"
          />
          <div style="padding: 14px">
            <span>{{ proj.project_name }}</span>
            <span>{{ proj.project_info }}</span>
            <v-contextmenu ref="contextmenu">
              <v-contextmenu-item @click="copyProj(lindex, index)"
                >复制工程</v-contextmenu-item
              >
              <v-contextmenu-item @click="deleteProj(lindex, index)"
                >删除工程</v-contextmenu-item
              >
              <v-contextmenu-item @click="openproj(lindex, index)"
                >打开项目</v-contextmenu-item
              >
            </v-contextmenu>
            <div class="bottom clearfix">
              <el-button type="text" class="button">操作按钮</el-button>
            </div>
          </div>
        </el-card>
      </el-col>
    </el-row>
  </el-main>
</template>

<script>
import { reqCopyProj, reqDelProj, reqProjList, reqProjInfo } from "@/api";

export default {
  data() {
    return {
      projList: [],
    };
  },
  computed: {
    projRowList() {
      let ret = [];
      for (let i = 0; i < this.projList.length; i++) {
        if (i % 4 === 0) ret.push([]);
        ret[ret.length - 1].push(this.projList[i]);
      }
      return ret;
    },
  },
  methods: {
    openproj(lindex, index) {
      let i = lindex * 4 + index;
      this.$router.push({
        name: "network",
        query: {
          proj_id: this.projList[i].project_id,
        },
        params: {
          proj_structure: this.projList[i].project_structure,
        },
      });
    },
    copyProj(lindex, index) {
      let i = lindex * 4 + index;
      let projProm = reqCopyProj({
        project_id: this.projList[i].project_id,
      })
        .then((res) => {
          console.log("reqCopyProj正确返回", res);
          return reqProjInfo({
            proj_id: res.project_id,
          });
        })
        .catch((err) => {
          console.log("reqCopyProj错误返回", err);
        });
      projProm
        .then((res) => {
          console.log("projProm res", res);
          this.projList.push({ ...res });
        })
        .catch((err) => {
          console.log("reqProjInfo错误返回", err);
        });
    },
    deleteProj(lindex, index) {
      let i = lindex * 4 + index;
      reqDelProj({
        project_id: this.projList[i].project_id,
      })
        .then((res) => {
          console.log("正确返回", res);
          this.projList.splice(i, 1); //本地删除
        })
        .catch((err) => {
          console.log("错误返回", err);
        });
    },
  },
  mounted() {
    let allProj = reqProjList()
      .then((res) => {
        console.log("reqProjList", res);
        let prom = [];
        res["proj_list"].forEach((element) => {
          console.log(element);
          prom.push(
            reqProjInfo({
              proj_id: element,
            })
          );
        });
        return Promise.all(prom);
      })
      .catch((err) => {
        console.log("reqProjList err", err);
      });
    allProj
      .then((resList) => {
        console.log("resList", resList);
        resList
          .forEach((res) => {
            this.projList.push({ ...res });
          })
          .catch((err) => {
            console.log("all错误返回", err);
          });
      })
      .catch((err) => {
        console.log("all err", err);
      });
  },
};
</script>

<style scoped lang="scss">
.content {
  height: 90vh;
  .el-row {
    margin-top: 30px;
    .el-col {
      display: flex;
      justify-content: space-around;
    }
  }
}
.card_style {
  cursor: pointer;
}
.time {
  font-size: 13px;
  color: #999;
}

.bottom {
  margin-top: 13px;
  line-height: 12px;
}

.button {
  padding: 0;
  float: right;
}

.image {
  width: 100%;
  display: block;
}

.clearfix:before,
.clearfix:after {
  display: table;
  content: "";
}

.clearfix:after {
  clear: both;
}
</style>